

Index: /home/cheetah/dev/doxygen/src/configoptions.cpp
===================================================================
--- /home/cheetah/dev/doxygen/src/configoptions.cpp	(revision 755)
+++ /home/cheetah/dev/doxygen/src/configoptions.cpp	(working copy)
@@ -1151,6 +1151,16 @@
   cs->setWidgetType(ConfigString::File);
   cs->addDependency("GENERATE_HTML");
   //----
+  cl = cfg->addList(
+                 "HTML_EXTRA_FILES",
+                 "The HTML_EXTRA_IMAGES tag can be used to specify one or more extra images or other source files which should be copied to the HTML output directory. Note that these files will be copied to the base HTML output directory. Use the\n"
+                 "$relpath$ marker in the HTML_HEADER and/or HTML_FOOTER files to load these\n"
+                 "files. In the HTML_STYLESHEET file, use the file name only. Also note that\n"
+                 "the files will be copied as-is; there are no commands or markers available."
+                );
+  cl->addDependency("GENERATE_HTML");
+  cl->setWidgetType(ConfigList::File);
+  //----
   ci = cfg->addInt(
                  "HTML_COLORSTYLE_HUE",
                  "The HTML_COLORSTYLE_HUE tag controls the color of the HTML output.\n"


Index: /home/cheetah/dev/doxygen/src/config.xml
===================================================================
--- /home/cheetah/dev/doxygen/src/config.xml	(revision 755)
+++ /home/cheetah/dev/doxygen/src/config.xml	(working copy)
@@ -804,6 +804,14 @@
 the style sheet file to the HTML output directory, so don&apos;t put your own 
 stylesheet in the HTML output directory as well, or it will be erased! 
 ' defval='' depends='GENERATE_HTML'/>
+    <option type='list' id='HTML_EXTRA_FILES' format='file' docs='
+The HTML_EXTRA_IMAGES tag can be used to specify one or more extra images or
+other source files which should be copied to the HTML output directory. Note
+that these files will be copied to the base HTML output directory. Use the 
+$relpath$ marker in the HTML_HEADER and/or HTML_FOOTER files to load these 
+files. In the HTML_STYLESHEET file, use the file name only. Also note that 
+the files will be copied as-is; there are no commands or markers available.
+' depends='GENERATE_HTML'/>
     <option type='int' id='HTML_COLORSTYLE_HUE' docs='
 The HTML_COLORSTYLE_HUE tag controls the color of the HTML output. 
 Doxygen will adjust the colors in the stylesheet and background images 


Index: /home/cheetah/dev/doxygen/src/doxygen.cpp
===================================================================
--- /home/cheetah/dev/doxygen/src/doxygen.cpp	(revision 755)
+++ /home/cheetah/dev/doxygen/src/doxygen.cpp	(working copy)
@@ -8619,6 +8619,29 @@
   }
 }
 
+static void copyExtraFiles()
+{
+  QStrList files = Config_getList("HTML_EXTRA_FILES");
+  for (uint i = 0; i < files.count(); ++i)
+  {
+    QCString fileName(files.at(i));
+    
+    if (!fileName.isEmpty())
+    {
+      QFileInfo fi(fileName);
+      if (!fi.exists()) 
+      {
+        err("Extra HTML file '%s' specified in HTML_EXTRA_FILES does not exist!\n", fileName.data());
+      }
+      else
+      {
+        QCString destFileName = Config_getString("HTML_OUTPUT")+"/"+fi.fileName().data();
+        Doxygen::indexList.addImageFile(fi.fileName().data());
+        copyFile(fileName, destFileName);
+      }
+    }
+  }
+}
 
 //! parse the list of input files
 static void parseFiles(Entry *root,EntryNav *rootNav)
@@ -10380,6 +10403,7 @@
     //if (Config_getBool("HTML_DYNAMIC_SECTIONS")) HtmlGenerator::generateSectionImages();
     copyStyleSheet();
     copyLogo();
+    copyExtraFiles();
     if (!generateTreeView && Config_getBool("USE_INLINE_TREES"))
     {
       FTVHelp::generateTreeViewImages();
